// -------------------------------------------
// EXAMPLE 1: Formal Specification Lecture 2     
// -------------------------------------------


//1. Note: results are given explicit names, and we may return several values.
// Very useful in specification!
method ManyReturns(x : int, y : int) returns (more : int, less :int)
{
  more := x+y;
  less := x-y;
  
  //2. Can't do this. Only allowed to update local variables or fields.
  //x := x+1;
  
  // 3. Assignment, parallel assignment *RHS* evaluated first.
  // Can often omit type-declaration.
  var a : int;
  a := 3;
  var b,c := true || false, 7+a;
  
  assert c == 10;
 
  // 4. Assertions: can be used to inspect vaules. RHS evaluated first!
  a,c := a+1, c-a;
 
  assert c == 7;
  assert a == 4; 
}
